## mingw-w64-cppwinrt-2.0.240111.5-1.src.tar.zst

=== test/old_tests/CMakeLists.txt ===
add_subdirectory(UnitTests)

=== test/old_tests/UnitTests/CMakeLists.txt ===
file(GLOB TEST_SRCS
    LIST_DIRECTORIES false
    CONFIGURE_DEPENDS
    *.cpp
)
list(FILTER TEST_SRCS EXCLUDE REGEX "/(Main|pch)\\.cpp")


# We can't build custom Component for mingw-w64 because it doesn't have an
# alternative to midl that can produce winmd files.
list(APPEND BROKEN_TESTS
    Boxing2
    Composable
    Errors
    Events
    FastInput
    Parameters
    StructCodeGen
    Structures
    delegate_weak_strong
    factory_cache
    get_activation_factory
    smart_pointers
)

list(APPEND BROKEN_TESTS
    # Missing `Windows.Applicationmodel.Activation.h`
    constexpr

    # Missing `Windows.ApplicationModel.Appointments.h`
    enum_flags

    # Missing component `Reflect`.
    # Test is also not included in the VS project.
    reflect

    # Segfault in winrt::impl::natvis::abi_val.
    # Test is also not included in the VS project.
    natvis
)

# Exclude broken tests
foreach(TEST_SRCS_EXCLUDE_ITEM IN LISTS BROKEN_TESTS)
    list(FILTER TEST_SRCS EXCLUDE REGEX "/${TEST_SRCS_EXCLUDE_ITEM}\\.cpp")
endforeach()

add_executable(test_old Main.cpp ${TEST_SRCS})
target_link_libraries(test_old runtimeobject synchronization)

if(NOT SKIP_LARGE_PCH)
    target_precompile_headers(test_old PRIVATE pch.h)
    set_source_files_properties(
        conditional_implements_pure.cpp
        PROPERTIES SKIP_PRECOMPILE_HEADERS true
    )
endif()

add_dependencies(test_old build-cppwinrt-projection)

add_test(
    NAME test_old
    COMMAND "$<TARGET_FILE:test_old>" ${TEST_COLOR_ARG}
)

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=cppwinrt
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.0.240111.5
_windows_rs_ver=0.52.0
pkgrel=1
pkgdesc="C++ language projection for Windows Runtime (WinRT) APIs (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://aka.ms/cppwinrt'
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/microsoft/cppwinrt/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/microsoft/windows-rs/archive/${_windows_rs_ver}/windows-rs-${_windows_rs_ver}.tar.gz")
sha256sums=('5ec49e9de3467161ef93185f0c627be6ed37200f19e18ac79e29e47fbeb69d0d'
            'fa6f1ad3677ee46ded34ad8811fc365a783d9aa414206a60b52dff261db85ef3')

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DCPPWINRT_BUILD_VERSION="${pkgver}" \
      -DBUILD_TESTING=OFF \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  "${MINGW_PREFIX}"/bin/cmake.exe --build .

  "${MINGW_PREFIX}"/bin/ctest.exe . || warning "Tests failed"
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  install -Dm755 cppwinrt.exe "${pkgdir}${MINGW_PREFIX}/bin/cppwinrt.exe"

  echo "SPDX-License-Identifier: MIT OR Apache-2.0
SPDX-FileCopyrightText: Copyright (c) Microsoft Corporation

Generated using .winmd files from https://github.com/microsoft/windows-rs
" > license.txt

  ./cppwinrt.exe -license license.txt \
    -input "${srcdir}/windows-rs-${_windows_rs_ver}/crates/libs/bindgen/default" \
    -output "${pkgdir}${MINGW_PREFIX}/include"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
